unit SzinKeUn;
(*
   Asszocilt mveletek:      (Kszsg)
   -------------- TSzin ---------------
   Be                              +
   Ki                              +
   String2Szin                     -
   Szin2String                     +
   Kod2Szin                        +
   Szin2Kod                        +
   Kov                             -
   Elo                             -
   Kisebb                          -
   HibasESzin                      +
*)
Interface
  Type
    TSzin=(Makk,Piros,Tok,Zold,NemSzin);
  Const
    MinSzin=Low(TSzin); MaxSzin=Pred(High(TSzin));
  Procedure Be(Const kerd:String; Var sz:TSzin);
  Procedure Ki(Const szov:String; Const sz:TSzin; Const uto:String);
  Function String2Szin(Const sz:String):TSzin;
  Function Szin2String(Const sz:TSzin):String;
  Function Kod2Szin(Const ko:Integer):TSzin;
  Function Szin2Kod(Const s:TSzin):Integer;
  Function Kov(Const sz:TSzin):TSzin;
  Function Elo(Const sz:TSzin):TSzin;
  Function Kisebb(Const sz1,sz2:TSzin):Boolean;
  Function HibasESzin(Var sz:TSzin):Boolean;

Implementation
  Const
    SSzin:Array [TSzin] of String=
          ('MAKK','PIROS','TOK','ZOLD','Nem szin');

  Procedure Be(Const kerd:String; Var sz:TSzin);
    Var
      sS:String;
  Begin
    Write(kerd); Readln(sS);
    sz:=String2Szin(sS);
  End{Be};

  Procedure Ki(Const szov:String; Const sz:TSzin; Const uto:String);
  Begin
    Write(szov+Szin2String(sz)+uto)
  End{Ki};

  Function String2Szin(Const sz:String):TSzin;
    Var
      i:TSzin;
  Begin
    {... hf ...}
  End{String2Szin};

  Function Szin2String(Const sz:TSzin):String;
  Begin
    Szin2String:=SSzin[sz]
  End{Szin2String};

  Function Kod2Szin(Const ko:Integer):TSzin;
   {Ef: ko ELEME [0..3]
    Uf: KodbolSzin(ko)=TSzin(ko)}
  Begin
    Kod2Szin:=TSzin(ko)
  End;

  Function Szin2Kod(Const s:TSzin):Integer;
   {Ef: -
    Uf: Szin2Kod(s)=Sorszam(s)}
  Begin
    Szin2Kod:=Ord(s)
  End;

  Function Kov(Const sz:TSzin):TSzin;
  Begin
    {... hf ...}
  End{Kov};

  Function Elo(Const sz:TSzin):TSzin;
  Begin
    {... hf ...}
  End{Elo};

  Function Kisebb(Const sz1,sz2:TSzin):Boolean;
  Begin
    {... hf ...}
  End{Kisebb};

  Function HibasESzin(Var sz:TSzin):Boolean;
   {Ef: -
    Uf: f=NemSzin  => HibasESzin=Igaz ES f=Min'TSzin
        f<>NemSzin => HibasESzin=Hamis}
  Begin
    If sz=NemSzin then
    Begin
      HibasESzin:=True; sz:=Low(TSzin)
    End
      else
    Begin
      HibasESzin:=False
    End;
  End{HibasESzin};

Begin

End.

