unit FiguKeUn;
(*
   Asszocilt mveletek:      (Kszsg)
   -------------- TFigure ---------------
   Be                              -
   Ki                              +
   String2Figura                   +
   Kod2Figura                      +
   Figura2String                   -
   Figura2Kod                      -
   Kov                             -
   Elo                             -
   Kisebb                          -
   HibasESzin                      +
*)

Interface
  Type
    TFigura=(VII,VIII,IX,X,Also,Felso,kiraly,Asz,NemFigura);
  Const
    MinFigura=Low(TFigura); MaxFigura=Pred(High(TFigura));

  Procedure Be(Const kerd:String; Var f:TFigura);
  Procedure Ki(Const szov:String; Const f:TFigura; Const uto:String);
  Function String2Figura(Const sz:String):TFigura;
  Function Figura2String(Const f:TFigura):String;
  Function Figura2Kod(Const f:TFigura):Integer;
  Function Kod2Figura(Const ko:Integer):TFigura;
  Function Kov(Const f:TFigura):TFigura;
  Function Elo(Const f:TFigura):TFigura;
  Function Kisebb(Const f1,f2:TFigura):Boolean;
  Function HibasEFigura(Var f:TFigura):Boolean;

Implementation
  Const
    SFigura:Array [TFigura] of String=
             ('VII','VIII','IX','X','ALSO',
              'FELSO','KIRALY','ASZ','Nem figura');

  Procedure Be(Const kerd:String; Var f:TFigura);
    Var
      fS:String;
  Begin
    {... hf ...}
  End{Be};

  Procedure Ki(Const szov:String; Const f:TFigura; Const uto:String);
  Begin
    Write(szov+Figura2String(f)+uto)
  End{Ki};

  Function String2Figura(Const sz:String):TFigura;
    Var
      i:TFigura;
  Begin
    i:=Low(TFigura);
    While (i<High(TFigura)) and (Figura2String(i)<>sz) do i:=Succ(i);
    String2Figura:=i
  End{String2Figura};

  Function Figura2String(Const f:TFigura):String;
  Begin
    {... hf ...}
  End{Figura2String};

  Function Figura2Kod(Const f:TFigura):Integer;
   {Ef: -
    Uf: Figura2Kod(f)=Sorszam(f)}
  Begin
    {... hf ...}
  End;

  Function Kod2Figura(Const ko:Integer):TFigura;
   {Ef: ko ELEME [0..7]
    Uf: KodbolFigura(ko)=TFigura(ko)}
  Begin
    Kod2Figura:=TFigura(ko)
  End;

  Function Kov(Const f:TFigura):TFigura;
  Begin
    {... hf ...}
  End{Kov};

  Function Elo(Const f:TFigura):TFigura;
  Begin
    {... hf ...}
  End{Elo};

  Function Kisebb(Const f1,f2:TFigura):Boolean;
  Begin
    {... hf ...}
  End{Kisebb};

  Function HibasEFigura(Var f:TFigura):Boolean;
   {Ef: -
    Uf: f=NemFigura  => HibasEFigura=Igaz ES f=Min'TFigura
        f<>NemFigura => HibasEFigura=Hamis}
  Begin
    If f=NemFigura then
    Begin
      HibasEFigura:=True; f:=Low(TFigura)
    End
      else
    Begin
      HibasEFigura:=False
    End;
  End{HibasEFigura};

Begin

End.
